unit SimpleLNET_1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  lNet, lNetComponents;

type

  { TForm1 }

  TForm1 = class(TForm)
   Button1: TButton;
   Button2: TButton;
   Button3: TButton;
   Edit1: TEdit;
   Edit2: TEdit;
   Label1: TLabel;
   Memo1: TMemo;
   Server: TLTCPComponent;
   Client: TLTCPComponent;
   procedure Button1Click(Sender: TObject);
   procedure Button2Click(Sender: TObject);
   procedure Button3Click(Sender: TObject);

  procedure fCOnError(const msg: string; aSocket: TLSocket);
  procedure fCOnDisconnect(aSocket: TLSocket);
  procedure fCOnAccept(aSocket: TLSocket);
  procedure fCOnReceive(aSocket: TLSocket);
  procedure fCOnConnect(aSocket: TLSocket);
  procedure fCOnCanSend(aSocket: TLSocket);

  procedure fSOnError(const msg: string; aSocket: TLSocket);
  procedure fSOnDisconnect(aSocket: TLSocket);
  procedure fSOnAccept(aSocket: TLSocket);
  procedure fSOnReceive(aSocket: TLSocket);
  procedure fSOnConnect(aSocket: TLSocket);
  procedure fSOnCanSend(aSocket: TLSocket);

  function INFO(aSocket:TLSocket;aTCP:TLTCPComponent):string;
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
Server.Listen(StrtoInt(Edit2.Text));
Server.OnAccept:= @fSOnAccept;
Server.OnError:= @fSOnError;
Server.OnConnect:= @fSOnConnect;
Server.OnCanSend:= @fSOnCanSend;
Server.OnDisconnect:= @fSOnDisconnect;
Server.OnReceive:= @fSOnReceive;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Client.Connect(Edit1.Text,StrtoInt(Edit2.Text));
Client.OnAccept:= @fCOnAccept;
Client.OnError:= @fCOnError;
Client.OnConnect:= @fCOnConnect;
Client.OnCanSend:= @fCOnCanSend;
Client.OnDisconnect:= @fCOnDisconnect;
Client.OnReceive:= @fCOnReceive;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
Client.SendMessage('Ping');
end;

procedure TForm1.fCOnError(const msg: string; aSocket: TLSocket);
begin
Memo1.Lines.Add('Client: Error ' + Info(aSocket,Client) + msg);
end;

procedure TForm1.fCOnDisconnect(aSocket: TLSocket);
begin
Memo1.Lines.Add('Client: Disconnect' + Info(aSocket,Client));
end;

procedure TForm1.fCOnAccept(aSocket: TLSocket);
begin
Memo1.Lines.Add('Client: Accept' + Info(aSocket,Client));
end;

procedure TForm1.fCOnReceive(aSocket: TLSocket);
var
  amsg:string;
begin
aSocket.GetMessage(amsg);
Memo1.Lines.Add('Client: Receive' + Info(aSocket,Client) + amsg);
end;

procedure TForm1.fCOnConnect(aSocket: TLSocket);
begin
Memo1.Lines.Add('Client: Connect' + Info(aSocket,Client));
end;

procedure TForm1.fCOnCanSend(aSocket: TLSocket);
begin
Memo1.Lines.Add('Client: CanSend' + Info(aSocket,Client));
end;

procedure TForm1.fSOnError(const msg: string; aSocket: TLSocket);
begin
Memo1.Lines.Add('Server: Error' + Info(aSocket,Server) + msg);
end;

procedure TForm1.fSOnDisconnect(aSocket: TLSocket);
begin
Memo1.Lines.Add('Server: Disconnect' + Info(aSocket,Server));
end;

procedure TForm1.fSOnAccept(aSocket: TLSocket);
begin
Memo1.Lines.Add('Server: Accept' + Info(aSocket,Server));
end;

procedure TForm1.fSOnReceive(aSocket: TLSocket);
var
  amsg:string;
begin
aSocket.GetMessage(amsg);
if amsg = 'Ping' then aSocket.SendMessage('Pong');
Memo1.Lines.Add('Server: Receive' + Info(aSocket,Server) + amsg);
end;

procedure TForm1.fSOnConnect(aSocket: TLSocket);
begin
Memo1.Lines.Add('Server: Connect' + Info(aSocket,Server));
end;

procedure TForm1.fSOnCanSend(aSocket: TLSocket);
begin
Memo1.Lines.Add('Server: CanSend' + Info(aSocket,Server));
end;

function TForm1.INFO(aSocket: TLSocket; aTCP: TLTCPComponent): string;
begin
result := 'Socket: (Local:' + aSocket.LocalAddress + ':' + InttoStr(aSocket.LocalPort) + ') (Peer: ' + aSocket.PeerAddress + ':' + InttoStr(aSocket.PeerPort) + ')  TCP: (Port: ' + InttoStr(aTCP.Port) + ')';
end;

end.

